<?php

namespace goodboyalex\php_components_pack\exceptions;

use Exception;

/**
 * Ошибка работы с расширением типов.
 *
 * @author Александр Бабаев
 * @package php_components_pack
 * @version 1.0
 * @since 1.1.1
 */
final class TypeException extends Exception
{
    /**
     * @var string $TypeName Имя типа.
     */
    public string $TypeName;

    /**
     * Конструктор.
     *
     * @param string $typeName Имя типа.
     * @param string $message Сообщение об ошибке.
     */
    public function __construct (string $typeName = "", string $message = "")
    {
        // Запускаем базовый конструктор
        parent::__construct($message);

        // Присваиваем тип
        $this->TypeName = $typeName;
    }
}